/* This select statement unions three queries which get the waits, CPU time, and current time in
seconds for the current session.  It subtracts the values for waits, CPU and time that were saved in
the table beforeownsession from the current values.  This gives us the wait time, cpu time, and elapsed time
for the period that was monitored. */


select 
after.TIMESOURCE, 
after.SECONDS-before.seconds elapsed_seconds 
from 
(select 
SID,event TIMESOURCE,
(TIME_WAITED/100) seconds 
from 
v$session_event 
where 
sid=(SELECT sid from v$session where audsid=USERENV('SESSIONID'))
union
select 
SID,
'CPU' TIMESOURCE,
(VALUE/100) seconds 
from 
v$sesstat 
where 
sid=(SELECT sid from v$session where audsid=USERENV('SESSIONID'))
and statistic#=(select statistic# from v$statname where name='CPU used by this session')
union
SELECT sid,
'REALELAPSED' TIMESOURCE,
(sysdate-to_date('01/01/1900','MM/DD/YYYY'))*24*60*60 seconds
from v$session where audsid=USERENV('SESSIONID')
) after,
beforeownsession before
where
before.SID=after.SID and
after.timesource=before.timesource
order by elapsed_seconds desc
;

drop table beforeownsession;
