/* beforeownsession stores current wait, cpu and time in seconds */

drop table beforeownsession;

/* Creates the table with the wait info for the current session */

create table beforeownsession as
select 
SID,
event TIMESOURCE,
(TIME_WAITED/100) seconds 
from v$session_event 
where 
sid=(SELECT sid from v$session where audsid=USERENV('SESSIONID'));

/* Gets the CPU usage for the current session */

insert into beforeownsession 
select 
SID,
'CPU' TIMESOURCE,
(VALUE/100) seconds 
from v$sesstat 
where 
sid=(SELECT sid from v$session where audsid=USERENV('SESSIONID'))
and statistic#=(select statistic# from v$statname where name='CPU used by this session');

commit;

/* Gets the time current session in seconds since 1/1/1900 */

insert into beforeownsession
SELECT sid,
'REALELAPSED' TIMESOURCE,
(sysdate-to_date('01/01/1900','MM/DD/YYYY'))*24*60*60 seconds
from v$session where audsid=USERENV('SESSIONID');
commit;